<?php

class morsylClass
{	
	public function __construct(){}

	// Attribute VB_Name = "basMorsyl"
	// // MORSYL.cpp
	// // MORSYL 0.0.8 - Keal's BitSlice Qubit Emulator
	
	// #include "stdafx.h"
	// #include "stdio.h"
	// #include "math.h"
	// #include "string.h"
	
	// /*int*/ main(/*int*/ argc, char* argv[])
	// {
	//     printf("MORSYL PHP 0.0.8\n");
	//     printf("2002 06/28 17:28 GMT-7\n");
	//     printf("2024 03/21 00:25 GMT-7\n");
	//     printf("Timothy Robert Keal alias jargon\n");
	//     printf("Keal's BitSlice Qubit Emulator\n");
	//     return 0;
	// }
	
	// /*'Keal's BitSlice Qubit Emulator
	// 'copyright 2002 06/28 Timothy Robert Keal alias jargon
	// 'copyright 2024 03/21 Timothy Robert Keal alias jargon
	// */
	
	Public Function DataAndLayer(/*int*/ $Tier=0, /*int*/ $Layer=0, /*array*/ $Data=[false])/*:boolean*/
	{
	    /*int*/ $V=0;
	    /*boolean*/ $Dg=false;
	    /*boolean*/ $DAnd=false;
	    For($V=0;$V<=$Tier;$V++)
		{
			$Dg = $this->Digit($Layer, $V);
	        $DAnd = ($Dg?$this->DataAndValue($Tier, $Dg, $DAnd, $Data[$V]):$DAnd);
		}
	    $DataAndLayer = $DAnd;
		return $DataAndLayer;
	}
	
	// unsigned __int64 DataAndLayer(void tier, void layer, void * data[])
	// {
	//     unsigned __int64 v;
	//     unsigned __int64 dg;
	//     unsigned __int64 DAnd;
	//     DAnd = &HFFFFFFFF;
	//     for(v = 0; v <= tier; v++)
	//     {
	//         dg = Digit(layer, v);
	//         DAnd = dg?DataAndValue(tier, dg, DAnd, data[v]):DAnd;
	//     }
	//     return DAnd;
	// }
	
	Public Function DataOrLayer( /*int*/ $Tier=0, /*int*/ $Layer=0, /*boolean*/ /*array*/ $Data=[false])/*:boolean*/
	{
		/*int*/ $V;
	    /*boolean*/ $Dg;
	    /*boolean*/ $DOr;
	    $DOr = False;
	    For($V=0;$V<=Tier;$V++)
		{
	        $Dg = $this->Digit($Layer, $V);
	        $DOr = ($Dg?$DOr:$this->DataOrValue($Tier, $Dg, $DOr, $Data[$V]));
	    }
	    $DataOrLayer = $DOr;
		return $DataOrLayer;
	}
	
	// unsigned __int64 DataOrLayer(void tier, void layer, void * data[])
	// {
	//     unsigned __int64 v;
	//     unsigned __int64 dg;
	//     unsigned __int64 DOr;
	//     DOr = 0;
	//     for(v = 0; v <= tier; v++)
	//     {
	//         dg = Digit(layer, v);
	//         DOr = dg?DOr:DataOrValue(tier, dg, DOr, data[v]);
	//     }
	//     return DOr;
	// }
	
	Public Function DataTier(/*int*/ $Tier=0, /*boolean*/ /*array*/ $Filter=[false], /*boolean*/ /*array*/ $Data=[false])/*:boolean*/
	{
		/*int*/ $Layer=0;
	    /*boolean*/ $DAnd=false;
	    /*boolean*/ $DOr=false;
	    $Layer = 0;
	    $DataTier = $this->DataLayer($Tier, $Layer, $Filter($Layer), $Data);
	    while($Layer < (1<<$Tier))
		{
	        $DataTier = $DataTier Or $this->DataLayer($Tier, $Layer, $Filter[$Layer], $Data);
	        $Layer++;
	    }
		return $DataTier;
	}
	
	// unsigned __int64 DataTier(void tier, void * filter[], void * data[])
	// {
	//     unsigned __int64 temp;
	//     unsigned __int64 layer;
	//     unsigned __int64 DAnd;
	//     unsigned __int64 DOr;
	//     layer = 0;
	//     temp = DataLayer(tier, layer, filter[layer], data, temp);
	//     for(; layer < 1 << tier; layer++)
	//     {
	//         temp = temp | DataLayer(tier, layer, filter[layer], data, temp);
	//     }
	//     if(layer == 1 << tier)
	//     {
	//         temp = temp | DataLayer(tier, layer, filter[layer], data, temp);
	//     }
	// }
	
	Public Function DataLayer(/*int*/ $Tier=0, /*int*/ $Layer=0, /*boolean*/ $Filter=false, /*boolean*/ $Data=false)/*:boolean*/
	{
	    /*boolean*/ $DAnd=false;
	    /*boolean*/ $DOr=false;
	    $DAnd = $this->DataAndLayer($Tier, $Layer, $Data);
	    $DOr = $this->DataOrLayer($Tier, $Layer, $Data);
	    $DataLayer = ($Filter & !(! ($DAnd) & $DOr));
		return $DataLayer;
	}
	
	// unsigned __int64 DataLayer(void tier, void layer, void filter, void data, void temp)
	// {
	//         DAnd = DataAndLayer(tier, layer, data);
	//         DOr = DataOrLayer(tier, layer, data);
	//         return (filter & !(!DAnd & DOr));
	// }
	
	Public Function DataAndValue(/*boolean*/ $Dg=false, /*boolean*/ $DAnd=false, /*boolean*/ $Value=false)/*:boolean*/
	{
		$DataAndValue = ($Dg?$DAnd & $Value:$DAnd);
		return $DataAndValue;
	}
	
	// unsigned __int64 DataAndValue(void dg, void DAnd, void value)
	// {
	//     return (dg?DAnd & value:DAnd);
	// }
	
	Public Function DataOrValue(/*boolean*/ $Dg=false, /*boolean*/ $DOr=false, /*boolean*/ $Value=false)/*:boolean*/
	{
	    $DataOrValue = ($Dg?$DOr | $Value:$DOr);
		return $DataOrValue;
	}
	
	// unsigned __int64 DataOrValue(void dg, void DOr, void value)
	// {
	//     return (dg?DOr | value:DOr);
	// }
	
	Public Function Digit(/*int*/ $Layer=0, /*int*/ $V=0)/*:boolean*/
	{
		$Digit = ($Layer>>$V);
		return $Digit;
	}
	
	// unsigned __int64 Digit(void a, void b)
	// {
	//     return ((a >> b) & 1);
	// }
	
	Public Function Digits(/*int*/ $A=0)/*:boolean*/
	{
	    $Digits = (floor(Log($A) / Log(2)));
		return $Digits;
	}
	
	// public sub Digits(a s) as /*boolean*/
	// {
	//     return (floor(log(a)/log(2)));
	// }
	
}
